package com.seitenbau.testing.instrumentation;

import com.seitenbau.testing.shared.config.RecorderConfiguration;

/**
 * Schnittstelle zur Erzeugung der Aufzeichen-Artefakte
 */
public interface IRecorderGenerator
{

  /**
   * Erzeugt alle ntigen Artefakte fr die gegebene Recorder
   * Konfiguration.
   *
   * @param config Das Konfigurationsmodell zum beschreiben was
   *        aufgezeichnet werden soll.
   *
   * @param targetSrcRootFolder Java-Source Verzeichnis. Anzugeben ist
   *        das Wurzelverzeichnis des Zielprojektes in welches die
   *        Artefakte generiert werden sollen. Fr ein normale Eclipse
   *        Projekt wre dies Beispielsweise der "src" Orderner.
   *        Dieser ist aber als kompletter Pfad in das Zielverzeichnis
   *        anzugeben, also mit Laufwerk und unterverzeichnissen.
   *
   * C:/projects/eclipse/workspaceDipl/testingPrj/src/main/java
   *
   */
  public void createRecorderArtifacts(RecorderConfiguration config,
      String targetSrcRootFolder);

  public void createRecorderArtifacts(RecorderConfiguration configuration,
      String targetSrcRootFolder, String targetResourceRootFolder);

}
