package com.seitenbau.testing.service;

import static com.seitenbau.testing.shared.helper.LoggerHelper.logger;

import com.seitenbau.testing.instrumentation.generator.RecorderGeneratorFactory;
import com.seitenbau.testing.shared.config.RecorderConfiguration;

public class Instrumentation
{

  /**
   * Erzeugen aller Artifakte zum Aufzeichnen
   *
   * @param configFileName
   * @param srcRootDirecotry
   */
  public static void createArtifacts(String configurationFileName,
      String srcRootDirecotry)
  {
    RecorderConfiguration cfg = RecorderConfiguration
        .loadFile(configurationFileName);

    createArtifacts(cfg, srcRootDirecotry);
  }

  /**
   * Erzeugen aller Artifakte zum Aufzeichnen
   *
   * @param config
   * @param targetSrcRootFolder
   */
  public static void createArtifacts(RecorderConfiguration configuration,
      String targetSrcRootFolder)
  {
    logger.info("Starting Recorder Artifacts Generation ...");
    RecorderGeneratorFactory.createRecorderGenerator(configuration)
        .createRecorderArtifacts(configuration, targetSrcRootFolder);
    logger.info("Recorder artifacts sucessfully created.");
  }

  public static void createArtifacts(RecorderConfiguration configuration,
      String targetSrcRootFolder, String targetResourceRootFolder)
  {
    logger.info("Starting Recorder Artifacts Generation ...");
    RecorderGeneratorFactory.createRecorderGenerator(configuration)
        .createRecorderArtifacts(configuration, targetSrcRootFolder,targetResourceRootFolder);
    logger.info("Recorder artifacts sucessfully created.");
  }

}
