package com.seitenbau.testing.service;

import com.seitenbau.testing.shared.config.TestConfiguration;
import com.seitenbau.testing.shared.helper.LoggerHelper;
import com.seitenbau.testing.testgenerator.generator.ITestGenerator;

public class TestGenerator
{

  /**
   * Erzeugen der Artefakte fr die Tests
   *
   * @param config
   * @param srcRootDirectory
   */
  public static void createTestArtifacts(ITestGenerator generator,
      TestConfiguration configuration, String testSourceRootFolder)
  {
    LoggerHelper.logger.info("Begin test generation ...");
    generator.createTestArtifacts(configuration, testSourceRootFolder, null);
    LoggerHelper.logger.info("Test Artifacts generated");
  }

  /**
   * Erzeugen der Artefakte fr die Tests
   *
   * @param config
   * @param srcRootDirectory
   */
  public static void createTestArtifacts(ITestGenerator generator,
      TestConfiguration configuration, String testSourceRootFolder,
      String testResourceRootFolder)
  {
    if(generator==null)
    {
      throw new IllegalArgumentException("Generator was null");
    }
    LoggerHelper.logger.info("Begin test generation ...");
    generator.createTestArtifacts(configuration, testSourceRootFolder,
        testResourceRootFolder);
    LoggerHelper.logger.info("Test Artifacts generated");
  }

}
