package com.seitenbau.testing.shared.aspects;

import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Annotation for ignore Recording Aspects.
 * 
 * If an Recorder Aspect is marked with this Annotation, it will not
 * create the concrete Tracer. It will only run with a NullTracer,
 * which actually does nothing.
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
@Inherited
public @interface IgnoreAspect 
{

}
