package com.seitenbau.testing.shared.config;

import java.util.Properties;

import com.thoughtworks.xstream.annotations.XStreamAlias;

/**
 * Konfigurations Modell fr die Datenbankverbindung.
 * 
 * Enthlt alle ntigen Informationen ber die Verbindung zur
 * Datenbank.
 * 
 */
public class DatabaseConfiguration
{

  /**
   * Datenbank connection URL
   */
  @XStreamAlias("DatabaseURL")
  private String myDatabaseURL = null;

  /**
   * Datenbank driver
   */
  @XStreamAlias("DriverClass")
  private String myDriverClass = null;

  /**
   * Datenbank Benutzername
   */
  @XStreamAlias("Username")
  private String myUsername = null;

  /**
   * Passwort fr den Datenbank Benutzer
   */
  @XStreamAlias("Password")
  private String myPassword = null;

  /**
   * Alternative DaoFactory, default ist die HibernateDaoFactory
   */
  @XStreamAlias("DatabaseFactory")
  private String myDatabaseFactory = null;

  /**
   * weitere Optionen
   * 
   * Abhngig von der gewhlten DaoFactory
   */
  @XStreamAlias("Properties")
  private Properties myProperties = null;

  public String getDatabaseFactory()
  {
    return myDatabaseFactory;
  }

  public void setDatabaseFactory(String databaseDao)
  {
    myDatabaseFactory = databaseDao;
  }

  public String getDatabaseURL()
  {
    return myDatabaseURL;
  }

  public void setDatabaseURL(String connection)
  {
    this.myDatabaseURL = connection;
  }

  public String getUsername()
  {
    return myUsername;
  }

  public void setUsername(String username)
  {
    this.myUsername = username;
  }

  public String getPassword()
  {
    return myPassword;
  }

  public void setPassword(String password)
  {
    this.myPassword = password;
  }

  public Properties getProperties()
  {
    return myProperties;
  }

  public void setProperties(Properties someProperties)
  {
    this.myProperties = someProperties;
  }

  public String getDriverClass()
  {
    return myDriverClass;
  }

  public void setDriverClass(String databaseDriverClass)
  {
    this.myDriverClass = databaseDriverClass;
  }

}
