package com.seitenbau.testing.shared.config;

import java.util.Properties;

import com.seitenbau.testing.shared.helper.Generics;
import com.seitenbau.testing.shared.tracer.ITracerListener;


/**
 * Konfiguration von Listener die am Tracer hngen.
 */
public class ListenerConfiguration implements IListenerConfiguration {
	private String className = null;

	/** Zustzliche Optionen fr den spezifischen Listener */
	private Properties Properties = null;

	public ListenerConfiguration() {

	}

	public ListenerConfiguration(Class<? extends ITracerListener> clazz) {
		setListenerClass(clazz);

	}

	public void setListenerClass(Class<? extends ITracerListener> clazz) {
		if (clazz != null) {
			setListenerClass(clazz.getCanonicalName());
		} else {
			clazz = null;
		}
	}

	private void setListenerClass(String canonicalName) {
		className = canonicalName;
	}

	public Class<ITracerListener> getListenerClass() {
		if (getClassName() == null) {
			return null;
		}
		try {
			Class<?> clazz = Class.forName(getClassName());
			// Class<ITracerListener> castedClazz = (Class<ITracerListener>)
			// clazz;
			return Generics.cast(clazz);
		} catch (ClassNotFoundException e) {
			System.err.println(e);
		}
		return null;
	}

	public String getClassName() {
		return className;
	}

	public void setClassName(String className) {
		this.className = className;
	}

	public Properties getProperties() {
		if (Properties == null) {
			Properties = new Properties();
		}
		return Properties;
	}

	public void setProperties(Properties someProperties) {
		this.Properties = someProperties;
	}
}
