package com.seitenbau.testing.shared.dao.hibernate;

import java.util.Date;

import com.seitenbau.testing.shared.dao.IRecordedTestCaseDao;
import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;
import com.seitenbau.testing.shared.model.RecordedTestCase;


public class RecordedTestCaseDao extends HibernateDao<RecordedTestCase>
    implements IRecordedTestCaseDao
{

  @Override
  public void delete(RecordedTestCase item)
  {
    if (item == null)
    {
      throw new IllegalArgumentException("null item cannot be deleted");
    }
    RecordedMethodConfiguration rmc = item.getRecordedMethodConfiguration();
    if (rmc == null)
    {
      throw new IllegalArgumentException("No RecordedMethodConfiguration set.");
    }

    // Aus Parent entfernen.
    rmc.getRecordedTestCases().remove(item);
    item.setRecordedMethodConfiguration(null);
    super.delete(item);
  }

  @Override
  protected Class<?> getClassType()
  {
    return RecordedTestCase.class;
  }

  public RecordedTestCase createNew(RecordedMethodConfiguration eventConfig)
  {
    RecordedTestCase rrun = new RecordedTestCase(eventConfig);

    rrun.setTimeStamp(new Date().toString());

    if (eventConfig != null)
    {
      eventConfig.addRecordedTestCase(rrun);
    }

    return rrun;
  }

}
