package com.seitenbau.testing.shared.dao.hibernate;

import com.seitenbau.testing.shared.dao.IRecordedTestDao;
import com.seitenbau.testing.shared.model.RecordedTest;
import com.seitenbau.testing.shared.model.RecordedTestCase;

public class RecordedTestDao extends HibernateDao<RecordedTest> implements
    IRecordedTestDao
{

  @Override
  public void delete(RecordedTest item)
  {
    if (item == null)
    {
      throw new IllegalArgumentException("RecordedTest is null.");
    }

    RecordedTestCase tCase = item.getRecordedTestCase();

    if (tCase == null)
    {
      throw new IllegalArgumentException("RecordedTestCase is not known for : "
          + item);
    }

    // Ausklinken aus RecordedTestCase Liste.
    tCase.removeRecordedTest(item);
    item.setRecordedTestCase(null);

    super.delete(item);
  }

  protected Class<?> getClassType()
  {
    return RecordedTest.class;
  }

  public RecordedTest createNew(RecordedTestCase rrun)
  {
    RecordedTest oc = create();
    if (rrun != null)
    {
      rrun.getRecordedTests().add(oc);
      oc.setRecordedTestCase(rrun);
    }
    return oc;
  }

}
