package com.seitenbau.testing.shared.filters;

import java.util.ArrayList;
import java.util.List;

import com.seitenbau.testing.shared.config.IXmlFilter;
import com.seitenbau.testing.shared.config.IXmlFilterConfiguration;
import com.seitenbau.testing.shared.helper.FileHelper;


public class SimpleTemplateMatchFilterConfiguration implements
    IXmlFilterConfiguration
{

  private List<String> myExcludeMatches;

  public Class<? extends IXmlFilter> getFilterClass()
  {
    return SimpleTemplateMatchfilter.class;
  }

  public void addExclude(String xmlMatch)
  {
    if (xmlMatch == null) 
    {
      return;
    }
    getExcludeMatches().add(xmlMatch);
  }

  public List<String> getExcludeMatches()
  {
    if (myExcludeMatches == null)
    {
      myExcludeMatches = new ArrayList<String>();
    }
    return myExcludeMatches;
  }

  public void setExcludeMatches(List<String> excludeMatches)
  {
    myExcludeMatches = excludeMatches;
  }

  public void saveXSLfile(String fname)
  {
    String[] array = new String[] {};
    array = myExcludeMatches.toArray(array);
    String xslt = FilterController.buildXslt(array);
    FileHelper.writeFile(fname, xslt);

  }
}
