package com.seitenbau.testing.shared.helper;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;

import com.thoughtworks.xstream.XStream;

/**
 * Helper for file content operations
 */
public class FileHelper
{

  public static void writeFile(String filename, String content)
  {
    try
    {
      FileOutputStream fo = new FileOutputStream(filename);
      new PrintStream(fo).print(content);
      fo.close();
    }
    catch (FileNotFoundException e)
    {
      e.printStackTrace();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
  }

  public static Object readObjectFromFile(XStream xs, String filename)
  {
    String s = FileHelper.readFile(filename);
    return xs.fromXML(s);
  }

  public static Object readObjectFromStream(XStream xs, InputStream is)
  {
    return xs.fromXML(is);
  }

  public static String readFile(String filename)
  {
    try
    {
      StringBuffer sb = new StringBuffer();
      FileInputStream fi = new FileInputStream(filename);
      while (fi.available() != 0)
      {
        sb.append((char) fi.read());
      }
      fi.close();

      return sb.toString();

    }
    catch (FileNotFoundException e)
    {
      e.printStackTrace();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    return null;
  }

  //
  // @SuppressWarnings("unchecked")
  // public static void setupStaticValues(Class targetClass, Object
  // values)
  // {
  // if (values instanceof HashMap)
  // {
  // HashMap<String, Object> map = (HashMap<String, Object>) values;
  // for (String key : map.keySet())
  // {
  // Field field;
  // try
  // {
  // field = targetClass.getDeclaredField(key);
  // String name = field.getName();
  // field.setAccessible(true);
  // Object obj = map.get(name);
  // field.set(null, obj);
  // }
  // catch (Exception e)
  // {
  // e.printStackTrace();
  // }
  // }
  // }
  //
  // }

  public static String readStream(InputStream stream)
  {

    StringBuffer out = new StringBuffer();
    byte[] b = new byte[4096];
    try
    {
      for (int n; (n = stream.read(b)) != -1;)
      {
        out.append(new String(b, 0, n));
      }
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    return out.toString();

  }

}
