package com.seitenbau.testing.shared.junit;

import java.io.IOException;

import org.custommonkey.xmlunit.XMLAssert;
import org.custommonkey.xmlunit.XMLTestCase;
import org.custommonkey.xmlunit.XMLUnit;
import org.custommonkey.xmlunit.exceptions.ConfigurationException;
import org.xml.sax.SAXException;

import com.seitenbau.testing.shared.model.ObjectSnapshot;
import com.thoughtworks.xstream.XStream;

public class XmlJUnitHelper extends XMLTestCase
{

  private static XStream myXStream = new XStream();

  public static void assertXUEquals(Object orginal, Object toCompare)
  {
    try
    {
      XMLAssert.assertXMLEqual(toXML(orginal), toXML(toCompare));
    }
    catch (SAXException e)
    {
      e.printStackTrace();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }

  }

  // /*
  // * no = Items in orgTrace n = items in trace O(n) + Sub methods
  // O(?)
  // */
  // public static void validateMethodCalls(List<InvocationBase>
  // orginalTrace,List<InvocationBase> trace) {
  // for (int i = 0; i < trace.size(); ++i) {
  // InvocationBase lc = trace.get(i);
  // if (i < orginalTrace.size()) {
  // InvocationBase olc = orginalTrace.get(i);
  //
  // assertXMLquals(olc.getPreState(),lc.getPreState());
  // assertXMLquals(olc.getReturnValue(),lc.getReturnValue());
  //
  // compareCallToBase(olc, lc, i);
  //
  //
  // assertXMLquals(olc.getPostState(),lc.getPostState());
  // }
  // }
  // assertEquals("Number of method calles
  // differs",orginalTrace.size(),trace.size());
  // }

  // // O(1)
  // private static void compareCallToBase( InvocationBase
  // olc,InvocationBase lc, int index) {
  // if( lc != null && olc != null) {
  // assertEquals("Different call to class",olc.getClass(),
  // lc.getClass());
  // if(lc instanceof InvocationMethod && olc instanceof
  // InvocationMethod) {
  // InvocationMethod lcm=(InvocationMethod) olc;
  // StringBuffer buf=new StringBuffer()
  // .append("Different Method invocation. Expected to call ")
  // .append( lcm.getMethodName())
  // .append( "() in Class: ")
  // .append( lcm.getClassName());
  //
  // assertEquals(buf.toString(),
  // olc.getClassName() , lc.getClassName() );
  // assertEquals(
  // lcm.getMethodName(),
  // lcm.getMethodName() );
  // } else if(lc instanceof InvocationNewOperator && olc instanceof
  // InvocationNewOperator) {
  // StringBuffer buf=new StringBuffer()
  // .append("Different new calls. Expected an instanciation of type:
  // ")
  // .append( olc.getClassName());
  // assertEquals(buf.toString(),olc.getClassName() ,
  // lc.getClassName() );
  // }
  // assertEquals ("Different target (at call order
  // "+index+")",olc.getClassName() , lc.getClassName() );
  // assertXMLquals (olc.getArgumentValues() ,
  // lc.getArgumentValues());
  // assertXMLquals (olc.getArgumentValues() ,
  // lc.getArgumentValues());
  //
  // } else {
  // fail("one parameter was null! (potentional corrupt internal
  // datastructure)");
  // }
  // }

  public static void assertXMLqualsNotNull(ObjectSnapshot obj1,
      ObjectSnapshot obj2)
  {
    assertNotNull(obj1);
    assertNotNull(obj2);
    try
    {
      // DocumentBuilder theParser = XMLUnit.getControlParser();
      // XMLUnit.setControlParser(
      // "org.apache.xerces.jaxp.DocumentBuilderFactoryImpl");
      XMLAssert.assertXMLEqual(obj1.getXMLString(), obj2.getXMLString());
    }
    catch (SAXException e)
    {
      e.printStackTrace();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
  }

  public static void assertXMLquals(String message, ObjectSnapshot expected,
      ObjectSnapshot actual)
  {
    if (expected != null && actual != null)
    {
      try
      {
        XMLUnit.setNormalize(true);
        XMLUnit.setIgnoreWhitespace(true);

        String expectedXML = expected.getXMLString();
        String actualXML = actual.getXMLString();

        XMLAssert.assertXMLEqual(message, expectedXML, actualXML);
      }
      catch (SAXException e)
      {
        e.printStackTrace();
      }
      catch (IOException e)
      {
        e.printStackTrace();
      }
      catch (ConfigurationException e)
      {
        e.printStackTrace();
      }
    }
  }

  public static void assertXMLquals(ObjectSnapshot expected,
      ObjectSnapshot actual)
  {
    if (expected != null && actual != null)
    {
      try
      {
        XMLUnit.setNormalize(true);
        XMLUnit.setIgnoreWhitespace(true);

        String expectedXML = expected.getXMLString();
        String actualXML = actual.getXMLString();

        XMLAssert.assertXMLEqual(expectedXML, actualXML);
      }
      catch (SAXException e)
      {
        e.printStackTrace();
      }
      catch (IOException e)
      {
        e.printStackTrace();
      }
      catch (ConfigurationException e)
      {
        e.printStackTrace();
      }
    }
  }

  // private static void breakdown(String s1) {
  // byte[] ba = s1.getBytes();
  // for(int i = 0;i<s1.length() ; ++i) {
  // byte b = ba[i];
  // if(b<33) {
  // System.out.print( s1.getBytes()[i] + "["+(int)b+"]");
  // }
  // }
  // System.out.println();
  // }

  private static String toXML(Object obj)
  {
    return getXStream().toXML(obj);
  }

  private static XStream getXStream()
  {
    return myXStream;
  }

  // public static void assertXMLquals(
  // FilterController filterObject
  // , ObjectSnapshot exceptionValue
  // , Object actual) {
  //
  // String expectedRawXML = exceptionValue.getXMLString();
  // String actualRawXML =
  // filterObject.makeSnapshot(actual).getXMLString();
  //
  // String expectedXML=filterObject.getFilteredXML(actual,
  // expectedRawXML);
  // System.out.println(expectedRawXML);
  // System.out.println(expectedXML);
  // }

}
