package com.seitenbau.testing.shared.locator;

import java.io.File;

public class RecorderPathLocator implements IRecorderPathLocator
{

  private String mySourceRoot;
  private String myResourceRoot;
  private String myPackage;
  private String myTestPrefix;

  public RecorderPathLocator(String filePrefix, String targetSrcRootFolder,
      String targetResourceRootFolder,String packageName)
  {
     myTestPrefix = filePrefix;
     mySourceRoot=targetSrcRootFolder;
     myResourceRoot=targetResourceRootFolder;
     myPackage=packageName;
  }

  public String getSourceRoot()
  {
    new File(mySourceRoot).mkdirs();
    return mySourceRoot;
  }

  public void setSourceRoot(String sourceRoot)
  {
    mySourceRoot = sourceRoot;
  }

  public String getResourceRoot()
  {
    new File(myResourceRoot).mkdirs();
    return myResourceRoot;
  }

  public void setResourceRoot(String resourceRoot)
  {
    myResourceRoot = resourceRoot;
  }

  public String getResourceFile(String filePostfix)
  {
    String root = TestPathLocator.asPathString( getResourceRoot());
    String packagePath = TestPathLocator.asPathString( getClassPackageAsFolder() );
    new File(root + packagePath).mkdirs();

    return root + packagePath + getTestPrefix() + filePostfix;
  }

  public String getPackage()
  {
    return myPackage;
  }

  public void setPackage(String package1)
  {
    myPackage = package1;
  }

  /**
   * @return The Package as Path, this only replaces '.' with the
   *         System's Path seperator. e.g.( com.example.dao --&gt;
   *         com/example/dao)
   */
  private String getClassPackageAsFolder()
  {
    return getPackage().replace('.', File.separatorChar);
  }

  public String getTestPrefix()
  {
    if(myTestPrefix==null)
    {
      return "";
    }
    return myTestPrefix;
  }

  public void setTestPrefix(String testPrefix)
  {
    myTestPrefix = testPrefix;
  }

}
