package com.seitenbau.testing.shared.locator;

import java.io.File;

public class TestPathClassBasedLocator extends TestPathLocator implements
    ITestPathClassBasedLocator
{
  private String myTestName;

  public TestPathClassBasedLocator(String className, String testName)
  {
    super(className);
//    myClassName = className;
    myTestName=testName;
  }

  public String getTestResourceFile(String pluginName, int runningNumber,
      String fileName)
  {
    String pluginfolder = getPluginFolder(pluginName);

    String pluginfilename = getPluginFileNameOnly(pluginName, runningNumber,
        fileName);

    return pluginfolder + pluginfilename;
  }

  protected String getPluginFolder(String pluginName)
  {
    StringBuffer buffer = new StringBuffer();
    buffer.append(getTestName());
    buffer.append( "Data");
    buffer.append(File.separator);
    buffer.append(pluginName);
    String path = buffer.toString();
    return asPathString(path);
  }

  public String getTestResourceFile(String pluginName, String fileName)
  {
    String pluginfolder = getPluginFolder(pluginName);

    String pluginfilename = getPluginFileNameOnly(pluginName, fileName);

    return pluginfolder + pluginfilename;
  }

  public String getTestResourceFile(String fileName)
  {
    return fileName;
  }

  public String getTestFile(String fileName)
  {
    return  fileName;
  }

  public String getTestFolder()
  {
    return "";
  }

  public String getTestResourceFolder()
  {
    return "";
  }

  public String getTestName()
  {
    if(myTestName==null)
    {
      return "";
    }
    return myTestName;
  }

  public void setTestName(String testName)
  {
    myTestName = testName;
  }

}
