package com.seitenbau.testing.shared.locator;

import java.io.File;

public class TestPathLocator
{

  protected String myClassName;
  private String myTestPrefix;

  public TestPathLocator(String testPrefix, String className)
  {
    myClassName = className;
    myTestPrefix=testPrefix;
  }

  public TestPathLocator(String className)
  {
    myClassName = className;
    myTestPrefix= ""; // Nix, nur klassen name
  }

  public String getClassName()
  {
    if (myClassName == null)
    {
      return "";
    }
    return myClassName;
  }

  public void setClassName(String className)
  {
    myClassName = className;
  }

  public static String asPathString(String testRootFolder)
  {
    if (testRootFolder == null)
    {
      return "";
    }
    if (testRootFolder.length() > 1)
    {
      char chr = testRootFolder.charAt(testRootFolder.length() - 1);
      if (chr != '/' && chr != '\\')
      {
        testRootFolder += File.separatorChar;
      }
    }
    return testRootFolder;
  }

  /**
   * @param pluginName
   * @param runningNumber
   * @param fileName
   * @return Only the filename.
   */
  public String getPluginFileNameOnly(String pluginName, int runningNumber,
      String fileName)
  {
    return String.format("%03d-%s", runningNumber, fileName);
  }

  public String getPluginFileNameOnly(String pluginName, String fileName)
  {
    return fileName;
  }

  protected String getPluginFolder(String pluginName)
  {
    StringBuffer buffer = new StringBuffer();
    buffer.append(getTestPrefix());
    buffer.append(getClassName());
    buffer.append("TestData");
    buffer.append(File.separator);
    buffer.append(pluginName);
    String path = buffer.toString();
    return asPathString(path);
  }

  public String getTestPrefix()
  {
    if(myTestPrefix==null)
    {
      return "";
    }
    return myTestPrefix;
  }

  public void setTestPrefix(String testPrefix)
  {
    myTestPrefix = testPrefix;
  }

}
