package com.seitenbau.testing.shared.model;

/**
 * Basis modell fr Methodenaufufe.
 *
 * Enthlt gegenber InvocationBase noch einen Methodenname sowie die
 * Modifier.
 *
 */
public class InvocationMethod extends InvocationBase
{

  private String myMethodName = null;

  private int myModifiers = 0;

  private boolean myVoidMethod;

  public String getMethodName()
  {
    return myMethodName;
  }

  public void setMethodName(String methodName)
  {
    myMethodName = methodName;
  }

  public int getModifiers()
  {
    return myModifiers;
  }

  public void setModifiers(int modifiers)
  {
    myModifiers = modifiers;
  }

  /**
   * Needed to avaoid a buggy
   * org.hibernate.property.BasicPropertyAccessor::getSetterOrNull
   *
   * The above mention method findes the Class Version here, and stops
   * searching up in the hierachy. Therefore a Illegal Argument
   * exception will be thrown at runtime. This effect has been seen
   * when using an JPA project & Spring 2.
   */
  public void setReturnType(String type)
  {
    super.setReturnType((String) type);
  }

  public void setReturnType(Class<?> type)
  {
    if (type != null && type != void.class)
    {
      setVoidMethod(false);
      super.setReturnType(type);
    }
    else
    {
      setVoidMethod(true);
      super.setReturnType((String) null);
    }
  }

  public void setVoidMethod(boolean b)
  {
    myVoidMethod = b;
  }

  public boolean isVoidMethod()
  {
    return myVoidMethod;
  }

}
