package com.seitenbau.testing.shared.model;

import java.util.List;
import java.util.Vector;

import com.seitenbau.testing.shared.config.ExcludeFieldConfiguration;
import com.seitenbau.testing.shared.config.MethodConfiguration;


/**
 * Angereicherte Datenbank Version der MethodConfiguration
 * 
 */
public class RecordedMethodConfiguration extends BasicDBModel
{

  private MethodConfiguration myMethodConfigurationDelegate = null;

  private String myName = null;

  private String myProjectName = null;

  private List<RecordedTestCase> myRecordedTestCases = null;

  private String myConfigurationSnapshot;

  public String getConfigurationSnapshot()
  {
    return myConfigurationSnapshot;
  }

  public void setConfigurationSnapshot(String configurationSnapshot)
  {
    myConfigurationSnapshot = configurationSnapshot;
  }

  public String getClassName()
  {
    return getMethodConfigurationDelegate().getClassName();
  }

  public void setClassName(String clazzName)
  {
    getMethodConfigurationDelegate().setClassName(clazzName);
  }

  public String getClassPackage()
  {
    return getMethodConfigurationDelegate().getPackageName();
  }

  public void setClassPackage(String clazzPackage)
  {
    getMethodConfigurationDelegate().setPackageName(clazzPackage);
  }

  public String getMethodName()
  {
    return getMethodConfigurationDelegate().getMethodName();
  }

  public void setMethodName(String clazzMethod)
  {
    getMethodConfigurationDelegate().setMethodName(clazzMethod);
  }

  public String getName()
  {
    return myName;
  }

  public void setName(String name)
  {
    myName = name;
  }

  public List<RecordedTestCase> getRecordedTestCases()
  {
    if (myRecordedTestCases == null)
    {
      myRecordedTestCases = new Vector<RecordedTestCase>();
    }
    return myRecordedTestCases;
  }

  public void addRecordedTestCase(RecordedTestCase recRun)
  {
    getRecordedTestCases().add(recRun);
  }

  public void setRecordedTestCases(List<RecordedTestCase> recordedRuns)
  {
    myRecordedTestCases = recordedRuns;
  }

  public void flatClone(BasicDBModel source)
  {
    throw new RuntimeException("Not Supported");
  }

  public String getProjectName()
  {
    return myProjectName;
  }

  public void setProjectName(String projectName)
  {
    myProjectName = projectName;
  }

  public String getReturnType()
  {
    return getMethodConfigurationDelegate().getReturnType();
  }

  public void setReturnType(String returnType)
  {
    getMethodConfigurationDelegate().setReturnType(returnType);
  }

  public String getParameters()
  {
    return getMethodConfigurationDelegate().getParameters();
  }

  public void setParameters(String parameters)
  {
    getMethodConfigurationDelegate().setParameters(parameters);
  }

  public MethodConfiguration getMethodConfigurationDelegate()
  {
    if (myMethodConfigurationDelegate == null)
    {
      myMethodConfigurationDelegate = new MethodConfiguration();
    }
    return myMethodConfigurationDelegate;
  }

  public void setMethodConfigurationDelegate(
      MethodConfiguration myMethodConfigurationDelegate)
  {
    this.myMethodConfigurationDelegate = myMethodConfigurationDelegate;
  }

  public List<ExcludeFieldConfiguration> getExcludeFields()
  {
    return this.myMethodConfigurationDelegate.getExcludeFields();
  }

  public void setExcludeFields(List<ExcludeFieldConfiguration> fields)
  {
    this.myMethodConfigurationDelegate.setExcludeFields(fields);
  }
}
