package com.seitenbau.testing.shared.model;

import java.util.List;
import java.util.Vector;

/**
 * Beschreibt einen Testfall.
 *
 * Ein Testfall unterscheidet sich von einem Methodenaufruf lediglich
 * im trace von enthaltenen Methoden/Operatoren Aufrufen.
 *
 */
public class RecordedTest extends InvocationMethod
{

  private List<InvocationBase> myTrace = null;

  /** the parent */
  private RecordedTestCase myRecordedTestCase = null;

  public RecordedTestCase getRecordedTestCase()
  {
    return myRecordedTestCase;
  }

  public void setRecordedTestCase(RecordedTestCase myRecordedTestCase)
  {
    this.myRecordedTestCase = myRecordedTestCase;
  }


  public List<InvocationBase> getTrace()
  {
    if (myTrace == null)
    {
      myTrace = new Vector<InvocationBase>();
    }
    return myTrace;
  }

  public void setTrace(List<InvocationBase> liveCalls)
  {
    myTrace = liveCalls;
  }

  public void addCallToBase(InvocationBase lc)
  {
    getTrace().add(lc);
  }

}
