package com.seitenbau.testing.shared.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import com.seitenbau.testing.shared.config.ListenerConfiguration;


/**
 * Menge an RecordedTest's
 * 
 * Dient dem Gruppieren von RecordedTest Elementen.
 */
public class RecordedTestCase extends DataModel
{

  private String myName = null;

  private String myTimeStamp = null;

  private String myDescription = null;

  private List<RecordedTest> myRecordedTests = null;

  /** Parent */
  private RecordedMethodConfiguration myRecordedMethodConfiguration;

  @Deprecated
  private boolean myTraceRecorded = true;

  private String myConfigurationSnapshot;

  private List<String> myRecordedFeatures;

  private Map<String, Object> myListenerSettings;

  public RecordedTestCase()
  {

  }

  public RecordedTestCase(RecordedMethodConfiguration ecfg)
  {
    myRecordedMethodConfiguration = ecfg;
  }

  public String getName()
  {
    if (myName == null)
    {
      myName = "default";
    }
    return myName;
  }

  public void setName(String name)
  {
    myName = name;
  }

  public String getDescription()
  {
    return myDescription;
  }

  public void setDescription(String description)
  {
    myDescription = description;
  }

  public List<RecordedTest> getRecordedTests()
  {
    if (myRecordedTests == null)
    {
      myRecordedTests = new Vector<RecordedTest>();
    }
    return myRecordedTests;
  }

  public void setRecordedTests(List<RecordedTest> occasions)
  {
    myRecordedTests = occasions;
  }

  public void addRecordedTest(RecordedTest occ)
  {
    getRecordedTests().add(occ);
  }

  public void setRecordedMethodConfiguration(RecordedMethodConfiguration econf)
  {
    myRecordedMethodConfiguration = econf;
  }

  public RecordedMethodConfiguration getRecordedMethodConfiguration()
  {
    return myRecordedMethodConfiguration;
  }

  public boolean getTraceRecorded()
  {
    return myTraceRecorded;
  }

  public void setTraceRecorded(boolean traceRecorded)
  {
    myTraceRecorded = traceRecorded;
  }

  public void removeRecordedTest(RecordedTest test)
  {
    getRecordedTests().remove(test);

  }

  public String getTimeStamp()
  {
    return myTimeStamp;
  }

  public void setTimeStamp(String timeStamp)
  {
    myTimeStamp = timeStamp;
  }

  public String getConfigurationSnapshot()
  {
    return myConfigurationSnapshot;
  }

  public void setConfigurationSnapshot(String configurationSnapshot)
  {
    myConfigurationSnapshot = configurationSnapshot;
  }

  public List<String> getRecordedFeatures()
  {
    if (myRecordedFeatures == null)
    {
      myRecordedFeatures = new ArrayList<String>();
    }
    return myRecordedFeatures;
  }

  public void setRecordedFeatures(List<String> recordedFeatures)
  {
    myRecordedFeatures = recordedFeatures;
  }

  public void addRecordedFeatures(String id)
  {
    getRecordedFeatures().add(id);
  }

  public void saveSettings(String string, ListenerConfiguration dconf)
  {

  }

  public Map<String, Object> getListenerSettings()
  {
    return myListenerSettings;
  }

  public void setListenerSettings(Map<String, Object> listenerSettings)
  {
    myListenerSettings = listenerSettings;
  }

}
