	package com.seitenbau.testing.shared.plugin;
	
	import java.util.ArrayList;
import java.util.Iterator;

import com.seitenbau.testing.shared.helper.Generics;
	
	
	public final class SBRecorderPlugins
	{
	
	  /** only static methods */
	  private SBRecorderPlugins()
	  {
	  }
	
	  public static <TYPE extends ISBRecorderPlugin> ArrayList<TYPE> getPlugins(
	      Class<TYPE> clazz)
	  {
	    ArrayList<TYPE> list = new ArrayList<TYPE>();
	    Iterator<TYPE> providers = Generics.cast(Service
	        .providers(ISBRecorderPlugin.class));
	    while (providers.hasNext())
	    {
	      ISBRecorderPlugin plugin = providers.next();
	      if (clazz.isInstance(plugin))
	      {
	        TYPE tmp = Generics.cast(plugin);
	        list.add(tmp);
	      }
	    }
	    return list;
	  }
	
	  public static <TYPE extends ISBRecorderPlugin> ArrayList<TYPE> detectPlugins(
	      Class<TYPE> clazz)
	  {
	    ArrayList<TYPE> list = new ArrayList<TYPE>();
	    Iterator<TYPE> providers = Generics.cast(Service.providers(clazz));
	    while (providers.hasNext())
	    {
	      list.add(providers.next());
	    }
	    return list;
	  }
	
	}
