package com.seitenbau.testing.shared.templateengine;

public interface ITemplateEngine
{

  // /**
  // * Setup the TemplateParams for this Engine. The Method must be
  // called.
  // * It's recommend to call it in the Constructor of a concrete
  // implementation.
  // *
  // * @param params
  // * The setup instance of TempalteParams.
  // */
  // public void setTemplateParams(ITemplateParams params);

  /**
   * Generate the output for a Specified Template.
   * 
   * @param templateID For possible Template IDs, see
   *        ITemplateConstants. This is not an enum, so you can
   *        specify your own IDs in future.
   * @return The content generated by the Template in usage of the
   *         TemplateParams.
   * 
   */
  public String generateOutput(IGenerator generator, ITemplateParams params);

  /**
   * Generate the Content of the Template an write it to a file you
   * know.
   * 
   * @param templateID For possible Template IDs, see
   *        ITemplateConstants. This is not an enum, so you can
   *        specify your own IDs in future.
   * 
   * @param filename
   */
  public void generateToFile(IGenerator generator, String filename,
      ITemplateParams params);

  /**
   * 
   * @param templateID For possible Template IDs, see
   *        ITemplateConstants. This is not an enum, so you can
   *        specify your own IDs in future.
   */
  public void generateToFile(IGenerator generator, ITemplateFileParams params);

}
