package com.seitenbau.testing.shared.templateengine;

import java.io.File;

import com.seitenbau.testing.shared.helper.FileHelper;


public class TemplateEngine implements ITemplateEngine
{

  public String generateOutput(IGenerator generator, ITemplateParams params)
  {
    if (generator == null)
    {
      throw new IllegalArgumentException("generator == null");
    }
    if (params == null)
    {
      throw new IllegalArgumentException("params == null");
    }
    return generator.generate(params);
  }

  public void generateToFile(IGenerator generator, String filename,
      ITemplateParams params)
  {
    if (generator == null)
    {
      throw new IllegalArgumentException("IGenerator not set.");
    }
    if (filename == null)
    {
      throw new IllegalArgumentException("filename not set.");
    }
    if (params == null)
    {
      throw new IllegalArgumentException("params not set.");
    }

    FileHelper.writeFile(filename, generateOutput(generator, params));
  }

  public void generateToFile(IGenerator generator, ITemplateFileParams params)
  {
    if (generator == null)
    {
      throw new IllegalArgumentException("generator not set.");
    }
    if (params == null)
    {
      throw new IllegalArgumentException("params not set.");
    }
    String output = generateOutput(generator, params);
    String path = null;
    String file = null;
    ITemplateFileParams fParam = (ITemplateFileParams) params;
    path = fParam.getFilePath();
    file = fParam.getFileName();
    if (path == null || file == null)
    {
      throw new IllegalArgumentException("Tempalte didn's set Path");
    }
    new File(path).mkdirs();

    FileHelper.writeFile(path + file, output);
  }

  // private ITemplateFileParams myParams=null;
  //
  // public void generateToFile(IGenerator generator, String filename)
  // {
  // if(myParams==null) {
  // throw new IllegalArgumentException("TemplatePArams not set.");
  // }
  // AtrHelper.writeFile(filename,generateOutput(generator));
  // }
  //
  // public void generateToFile(IGenerator generator) {
  // if(myParams==null) {
  // throw new IllegalArgumentException("TemplatePArams not set.");
  // }
  // String output = generateOutput(generator);
  // String path = myParams.getFilePath();
  // String filename = myParams.getFileName();
  // if(filename==null || path==null) {
  // throw new IllegalArgumentException("Template did not set filename
  // / path!.");
  // }
  // new File(path).mkdirs();
  // AtrHelper.writeFile(path+filename,output);
  // }
  //
  // public void setTemplateParams(ITemplateParams params) {
  // myParams=(ITemplateFileParams) params;
  // }
  //
  // protected ITemplateParams getParams() {
  // return myParams;
  // }
  //
  // public String generateOutput(IGenerator generator) {
  // if(generator==null) {
  // throw new IllegalArgumentException("generator == null");
  // }
  // return generator.generate(getParams());
  // }
  //
  // public static void generateFile( IGenerator generator,
  // ITemplateParams params) {
  // ITemplateEngine te = new TemplateEngine();
  // te.setTemplateParams(params);
  // te.generateToFile(generator);
  // }

}
