package com.seitenbau.testing.shared.tracer;

import com.seitenbau.testing.shared.config.IListenerConfiguration;
import com.seitenbau.testing.shared.config.MethodConfiguration;
import com.seitenbau.testing.shared.dao.IDaoFactory;
import com.seitenbau.testing.shared.model.InvocationMethod;
import com.seitenbau.testing.shared.model.InvocationNewOperator;
import com.seitenbau.testing.shared.model.RecordedTest;
import com.seitenbau.testing.shared.model.RecordedTestCase;

/**
 * Interface zum Anmelden von Listener an ITracerWithListener Objekten
 * 
 * Gleich wie Tracer, nur anstatte AspectJ Abhngigkeit, nur noch
 * Abhngig von Modell.
 * 
 */
public interface ITracerListener
{

  public void initListener(MethodConfiguration mcfg,
      IListenerConfiguration listenerConfiguration, IDaoFactory daoFactory);

  public void initTestCase(RecordedTestCase theCase);

  public void enteringTargetMethod(RecordedTest recordedTest);

  public void throwedException(RecordedTest recordedTestInstance,
      Throwable theThrowable);

  public void subMethodEntering(InvocationMethod subMethodInstance);

  public void subMethodLeaving(InvocationMethod subMethodInstance,
      Object theReturnValue);

  public void subMethodThrowedException(InvocationMethod subMethodInstance,
      Throwable theThrowable);

  public void newOperatorEntering(InvocationNewOperator newOperatorInstance);

  public void newOperatorThrowedException(InvocationNewOperator newOperator,
      Throwable theThrowable);

  public void newOperatorLeaving(InvocationNewOperator newOperatorInstance,
      Object theReturnValue);

  public void leavingTargetMethod(RecordedTest recordedTest,
      Object theReturnValue);

  public void finished(RecordedTest recordedTest);

}
