package com.seitenbau.testing.shared.tracer;

import java.util.List;

/**
 * Dieser Art von Tracer dienen als Subjekte.
 * 
 */
public interface ITracerWithListener extends ITracer
{

  /**
   * Hinzufgen eines Listeners
   * 
   * @param listener Der hinzuzufgende Listener
   */
  public void addTracerListener(ITracerListener listener);

  /**
   * Abmelden eines hinzugefgten Listeners
   * 
   * @param listener Ein bereists hinzuzufgende Listener der
   *        abgemeldet wird. Ist dieser nicht angemeldet gewesen, so
   *        passiert eben nichts.
   */
  public void removeTracerListener(ITracerListener listener);

  public List<ITracerListener> getListeners();
}
