package com.seitenbau.testing.shared.tracer.flow;


import org.aspectj.lang.JoinPoint;

import com.seitenbau.testing.shared.model.RecordedTest;
import com.seitenbau.testing.shared.tracer.ITracer;

public interface IFlowControl extends ITracer
{

  public boolean targetMethodShouldProceed(JoinPoint theJoinPoint);

  public boolean targetMethodSchouldThrowException(JoinPoint theJoinPoint,
      Throwable throwable);

  /**
   * This is called when a Exception has to be thrown.
   * 
   * Either return the passed OldException, or proxy it. your choice.
   * 
   * @param theJoinPoint
   * 
   * @param theOldException The Old Excpetion, if the method was not
   *        proceeded (your targetMethodShouldProceed retuned false),
   *        there was no code executed to really throw a Excetion this
   *        time. In this case this Parameter is <code>null</code>.
   * 
   * @return
   */
  public Throwable targetMethodThrowingException(JoinPoint theJoinPoint,
      Throwable theOldException);

  public Object targetMethodReturningValue(JoinPoint theJoinPoint,
      Object theOldValue);

  public boolean subMethodShouldProceed(JoinPoint theJoinPoint);

  public boolean subMethodSchouldThrowException(JoinPoint theJoinPoint,
      Throwable throwable);

  public Throwable subMethodThrowingException(JoinPoint theJoinPoint,
      Throwable theOldException);

  public Object subMethodReturningValue(JoinPoint theJoinPoint,
      Object theOldValue);

  public boolean subNewOperatorShoudProceed(JoinPoint theJoinPoint);

  public boolean subNewOperatorSchouldThrowException(JoinPoint theJoinPoint,
      Throwable throwable);

  public Throwable subNewOperatorThrowingException(JoinPoint theJoinPoint,
      Throwable theOldException);

  public Object subNewOperatorReturningValue(JoinPoint theJoinPoint,
      Object theOldValue);

  public RecordedTest getTest();

}
