package com.seitenbau.testing.shared.tracer.flow;


import org.aspectj.lang.JoinPoint;

import com.seitenbau.testing.shared.config.MethodConfiguration;
import com.seitenbau.testing.shared.model.RecordedTest;

/**
 * Adapter for ITracerFlowControl, acts like there is no flowControl
 * active
 */
public class TracerFlowControlAdapter implements IFlowControl
{

  public Object subMethodReturningValue(JoinPoint theJoinPoint,
      Object theOldValue)
  {
    return theOldValue;
  }

  public boolean subMethodSchouldThrowException(JoinPoint theJoinPoint,
      Throwable throwable)
  {
    return throwable != null;
  }

  public boolean subMethodShouldProceed(JoinPoint theJoinPoint)
  {
    return true;
  }

  public Throwable subMethodThrowingException(JoinPoint theJoinPoint,
      Throwable theOldException)
  {
    return theOldException;
  }

  public Object subNewOperatorReturningValue(JoinPoint theJoinPoint,
      Object theOldValue)
  {
    return theOldValue;
  }

  public boolean subNewOperatorSchouldThrowException(JoinPoint theJoinPoint,
      Throwable throwable)
  {
    return throwable != null;
  }

  public boolean subNewOperatorShoudProceed(JoinPoint theJoinPoint)
  {
    return true;
  }

  public Throwable subNewOperatorThrowingException(JoinPoint theJoinPoint,
      Throwable theOldException)
  {
    return theOldException;
  }

  public Object targetMethodReturningValue(JoinPoint theJoinPoint,
      Object theOldValue)
  {
    return theOldValue;
  }

  public boolean targetMethodSchouldThrowException(JoinPoint theJoinPoint,
      Throwable throwable)
  {
    return throwable != null;
  }

  public boolean targetMethodShouldProceed(JoinPoint theJoinPoint)
  {
    return true;
  }

  public Throwable targetMethodThrowingException(JoinPoint theJoinPoint,
      Throwable theOldException)
  {
    return theOldException;
  }

  public void setConfigurationMethod(MethodConfiguration mcfg)
  {

  }

  public void subMethodEntering(JoinPoint thisJoinPoint)
  {
  }

  public void subMethodProceeded(JoinPoint thisJoinPoint, Object theReturnValue)
  {
  }

  public void subMethodThrowedException(JoinPoint thisJoinPoint,
      Throwable throwable)
  {
  }

  public void subNewOperatorEntering(JoinPoint thisJoinPoint)
  {
  }

  public void subNewOperatorProceeded(JoinPoint thisJoinPoint,
      Object theReturnValue)
  {
  }

  public void subNewOperatorThrowedException(JoinPoint thisJoinPoint,
      Throwable throwable)
  {
  }

  public void targetMethodEntering(JoinPoint thisJoinPoint)
  {
  }

  public void targetMethodProceeded(JoinPoint thisJoinPoint,
      Object theReturnValue)
  {
  }

  public void targetMethodThrowedException(JoinPoint thisJoinPoint,
      Throwable throwable)
  {
  }

  public RecordedTest getTest()
  {
    return null;
  }
}
