package com.seitenbau.testing.shared.tracer.listener;

import com.seitenbau.testing.shared.model.RecordedTest;
import com.seitenbau.testing.shared.tracer.ITracer;
import com.seitenbau.testing.shared.tracer.ITracerAwareListener;
import com.seitenbau.testing.shared.tracer.RmiTracer;

public class RmiLogListener extends NullListener implements ITracerAwareListener
{

  @Override
  public void enteringTargetMethod(RecordedTest recordedTest)
  {
    if(myRmiTracer!=null) {
//      myRmiTracer.logMessage("enteringTargetMethod : " + recordedTest);
      myRmiTracer.logMessage("enteringTargetMethod : " + recordedTest.getClassName() );
      myRmiTracer.logMessage("enteringTargetMethod : " + recordedTest.getMethodName() );


    }
  }

  @Override
  public void finished(RecordedTest recordedTest)
  {
    if(myRmiTracer!=null) {
      myRmiTracer.logMessage("finished : " + recordedTest.getClassName() );
      myRmiTracer.logMessage("finished : " + recordedTest.getMethodName() );

//      myRmiTracer.logMessage("finished : " + recordedTest);
    }
  }

  private RmiTracer myRmiTracer;

  public void registerTracer(ITracer tracer)
  {
    if(tracer instanceof RmiTracer)
    {
      myRmiTracer= (RmiTracer) tracer;
    }
  }

}
