package com.seitenbau.testing.shared.xstream;

import java.io.Reader;

import com.thoughtworks.xstream.io.xml.XmlFriendlyReplacer;
import com.thoughtworks.xstream.io.xml.XppReader;

/**
 * Hebt die Escapte Seq. von Sonderzeichen im XML Strom wieder auf.
 * 
 * Da XML keine Sonderzeichen (Insbesondere 0) erlaubt, mussten diese
 * beim wegschreiben mit einem Escapezeichen \{0} versehen werden.
 * Dieser Reader hebt diese Sequenz wieder auf und konvertiert diese
 * zurck in das ursprngliche Zeichen.
 * 
 */
public class HideControlCharPrettyPrintReader extends XppReader
{

  public HideControlCharPrettyPrintReader(Reader reader,
      XmlFriendlyReplacer replacer)
  {
    super(reader, replacer);
  }

  @Override
  public String getValue()
  {
    int start, end, last;
    StringBuffer sb = new StringBuffer();

    String value = super.getValue();

    end = -1;
    last = 0;
    start = value.indexOf("\\");

    if (start == -1)
    {
      return value;
    }

    while (start != -1)
    {
      char c = value.charAt(start + 1);
      if (c == '\\')
      {
        sb.append(value.substring(last, start + 1));
        last = start + 2;
      }
      else if (c == '{')
      {
        end = value.indexOf("}", start);
        sb.append(value.substring(last, start));
        if (end <= (start + 4))
        {
          sb.append(decodeChar(value.substring(start, end + 1)));
          last = end + 1;
        }
      }
      else
      {
      }
      start = value.indexOf("\\", last);
    }
    sb.append(value.substring(last));
    return sb.toString();
  }

  protected String decodeChar(String text)
  {
    StringBuffer sb = new StringBuffer();
    String value = text.substring(2, text.length() - 1);
    int v = Integer.parseInt(value);

    sb.append((char) v);
    return sb.toString();
  }

}
