package com.seitenbau.testing.shared.xstream;

import java.io.Reader;
import java.io.Writer;

import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;
import com.thoughtworks.xstream.io.xml.PrettyPrintWriter;
import com.thoughtworks.xstream.io.xml.XppDriver;
import com.thoughtworks.xstream.io.xml.XppReader;

/**
 * Verhindert das Auftauchen von Control Characters im XML Strom
 */
public class HideControlCharXppDriver extends XppDriver
{

  @Override
  public HierarchicalStreamReader createReader(Reader xml)
  {
    XppReader reader = new HideControlCharPrettyPrintReader(xml,
        xmlFriendlyReplacer());
    return reader;
  }

  public HierarchicalStreamWriter createWriter(Writer out)
  {
    PrettyPrintWriter ppw = new HideControlCharPrettyPrintWriter(out,
        xmlFriendlyReplacer());
    return ppw;
  }

}
