package com.seitenbau.testing.templates;

import com.seitenbau.testing.shared.templateengine.ITemplateParams;
import com.seitenbau.testing.shared.templateengine.IGenerator;

public class JUnit4_AspectGenerator implements IGenerator
{
  protected static String nl;
  public static synchronized JUnit4_AspectGenerator create(String lineSeparator)
  {
    nl = lineSeparator;
    JUnit4_AspectGenerator result = new JUnit4_AspectGenerator();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "package ";
  protected final String TEXT_2 = ";";
  protected final String TEXT_3 = NL + "import org.aspectj.lang.JoinPoint;" + NL + "import org.aspectj.lang.reflect.CodeSignature;" + NL + "import org.aspectj.lang.reflect.MethodSignature;" + NL + "" + NL + "import com.seitenbau.testing.shared.dao.IDaoFactory;" + NL + "import com.seitenbau.testing.shared.dao.IInvocationMethodDao;" + NL + "import com.seitenbau.testing.shared.dao.IInvocationNewOperatorDao;" + NL + "import com.seitenbau.testing.shared.aspects.AbstractMockAspect;" + NL + "import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;" + NL + "import com.seitenbau.testing.shared.model.InvocationBase;" + NL + "import com.seitenbau.testing.shared.model.InvocationMethod;" + NL + "import com.seitenbau.testing.shared.model.InvocationNewOperator;" + NL + "import com.seitenbau.testing.shared.model.RecordedTest;" + NL + "import com.seitenbau.testing.shared.model.RecordedTestCase;" + NL + "import static junit.framework.Assert.*;" + NL + "import com.seitenbau.testing.shared.tracer.IUnderTrace;" + NL + "import com.seitenbau.testing.shared.tracer.ITracer;" + NL + "import com.seitenbau.testing.shared.tracer.flow.IFlowControl;" + NL + "import com.seitenbau.testing.shared.junit.IUnderFlowControl;" + NL + "" + NL + "public aspect ";
  protected final String TEXT_4 = "AtrTestAspect extends AbstractMockAspect {" + NL + "" + NL + "/*\tprotected ITracer createAspectTracer() {" + NL + "\t\tJUnitTracer tracer=new JUnitTracer() {" + NL + "\t\t\tprotected void setRecordedTestToJUnit(RecordedTest theRecordedTest) {" + NL + "\t\t\t\t";
  protected final String TEXT_5 = "AtrTest.setRecordedTest(theRecordedTest);" + NL + "\t\t\t}" + NL + "\t\t};" + NL + "\t\t";
  protected final String TEXT_6 = "AtrTest.setupTracer(tracer);" + NL + "\t\treturn tracer;" + NL + "\t} */" + NL + "" + NL + "\tprotected IFlowControl createFlowControl() {" + NL + "\t\treturn ";
  protected final String TEXT_7 = "AtrTest.createFlowControl();" + NL + "\t}" + NL + "" + NL + "\tprotected pointcut pc_CallToTrace() :" + NL + "\t\t\t\texecution(";
  protected final String TEXT_8 = "  ";
  protected final String TEXT_9 = ".";
  protected final String TEXT_10 = "(";
  protected final String TEXT_11 = "))" + NL + "\t\t\t\t&& cflow( execution(* *AtrTest.*(..)) )" + NL + "\t\t\t;" + NL + "" + NL + "\tprotected pointcut pc_allMethodCalls() : call(* *(..))" + NL + "\t\t\t\t&& !within(";
  protected final String TEXT_12 = "*Aspect)" + NL + "\t\t\t\t&&  withincode(";
  protected final String TEXT_13 = " ";
  protected final String TEXT_14 = ".";
  protected final String TEXT_15 = "(";
  protected final String TEXT_16 = "))" + NL + "\t\t\t\t&& cflow( execution(* *AtrTest.*(..)) )" + NL + "\t\t\t;" + NL + "" + NL + "\tprotected pointcut pc_allNewCalls() : call(* .new(..))" + NL + "\t\t\t\t&& !within(";
  protected final String TEXT_17 = "*Aspect)" + NL + "\t\t\t\t&&  withincode(";
  protected final String TEXT_18 = " ";
  protected final String TEXT_19 = ".";
  protected final String TEXT_20 = "(";
  protected final String TEXT_21 = "))" + NL + "\t\t\t\t&& cflow( execution(* *AtrTest.*(..)) )" + NL + "\t\t\t;" + NL + "" + NL + "\tdeclare parents: ";
  protected final String TEXT_22 = "AtrTest implements IUnderFlowControl;" + NL + "" + NL + "\tpublic static IFlowControl ";
  protected final String TEXT_23 = "AtrTest.createFlowControl() {" + NL + "\t\treturn  myTestControl.getFlowControl();" + NL + "\t}" + NL + "" + NL + "//\tdeclare parents: ";
  protected final String TEXT_24 = "AtrTest implements IUnderTrace;" + NL + "//" + NL + "//\tprivate static RecordedTest ";
  protected final String TEXT_25 = "AtrTest.myCurrentRecordedTest;" + NL + "//" + NL + "//\tpublic RecordedTest ";
  protected final String TEXT_26 = "AtrTest.getCurrentRecordedTest() {" + NL + "//\t\tassertNotNull(\"Target Method was not called! (Aspect didn't set CurrentRecordedTest)\",myCurrentRecordedTest);" + NL + "//\t\treturn myCurrentRecordedTest;" + NL + "//\t}" + NL + "//" + NL + "//\tpublic static void ";
  protected final String TEXT_27 = "AtrTest.setRecordedTest(RecordedTest currentRecordedTest) {" + NL + "//\t\tmyCurrentRecordedTest = currentRecordedTest;" + NL + "//\t}" + NL + "}" + NL;

	/* (non-javadoc)
    * @see IGenerator#generate(Object)
    */
	@SuppressWarnings("unchecked")
	public String generate(ITemplateParams argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
     /* 
     JUnitParams params=(JUnitParams)argument;
     //RecordedTestCase rr=(RecordedTestCase)params.get(ITemplateParams.OBJ_RECORDED_RUN); 
     RecordedMethodConfiguration ecfg=params.getMethodConfiguration();


    String packageAndClassName=ecfg.getClassName();
    if( ecfg.getClassPackage().length()>0) {
    	packageAndClassName=ecfg.getClassPackage()+"."+ecfg.getClassName();
    }
	String javaPackage=ecfg.getClassPackage();
	if( javaPackage.length() > 0 ) {

    stringBuffer.append(TEXT_1);
    stringBuffer.append(ecfg.getClassPackage());
    stringBuffer.append(TEXT_2);
     } 
    stringBuffer.append(TEXT_3);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_4);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_5);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_6);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_7);
    stringBuffer.append(ecfg.getReturnType());
    stringBuffer.append(TEXT_8);
    stringBuffer.append(packageAndClassName);
    stringBuffer.append(TEXT_9);
    stringBuffer.append(ecfg.getMethodName());
    stringBuffer.append(TEXT_10);
    stringBuffer.append(ecfg.getParameters());
    stringBuffer.append(TEXT_11);
    stringBuffer.append(packageAndClassName);
    stringBuffer.append(TEXT_12);
    stringBuffer.append(ecfg.getReturnType());
    stringBuffer.append(TEXT_13);
    stringBuffer.append(packageAndClassName);
    stringBuffer.append(TEXT_14);
    stringBuffer.append(ecfg.getMethodName());
    stringBuffer.append(TEXT_15);
    stringBuffer.append(ecfg.getParameters());
    stringBuffer.append(TEXT_16);
    stringBuffer.append(packageAndClassName);
    stringBuffer.append(TEXT_17);
    stringBuffer.append(ecfg.getReturnType());
    stringBuffer.append(TEXT_18);
    stringBuffer.append(packageAndClassName);
    stringBuffer.append(TEXT_19);
    stringBuffer.append(ecfg.getMethodName());
    stringBuffer.append(TEXT_20);
    stringBuffer.append(ecfg.getParameters());
    stringBuffer.append(TEXT_21);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_22);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_23);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_24);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_25);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_26);
    stringBuffer.append(ecfg.getClassName());
    stringBuffer.append(TEXT_27);
     */ 
    return stringBuffer.toString();
  }
}