package com.seitenbau.testing.templates;

import com.seitenbau.testing.shared.templateengine.ITemplateParams;
import com.seitenbau.testing.shared.templateengine.IGenerator;

import com.seitenbau.testing.shared.helper.*;
import com.seitenbau.testing.testgenerator.datadriven.*;
import com.seitenbau.testing.shared.templateengine.*;
import java.util.*;
import com.seitenbau.testing.shared.model.*;
import com.seitenbau.testing.shared.locator.*;
import com.seitenbau.testing.testgenerator.*;
import com.seitenbau.testing.shared.junit.*;;

public class JUnit4_DataDrivenTestGenerator implements IGenerator
{
  protected static String nl;
  public static synchronized JUnit4_DataDrivenTestGenerator create(String lineSeparator)
  {
    nl = lineSeparator;
    JUnit4_DataDrivenTestGenerator result = new JUnit4_DataDrivenTestGenerator();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "package ";
  protected final String TEXT_2 = ";";
  protected final String TEXT_3 = NL + "import java.lang.reflect.Method;" + NL + "import com.seitenbau.testing.shared.helper.ReflectionHelper;" + NL + "import com.seitenbau.junit.ParameterizedTestRunner;" + NL + "import com.seitenbau.junit.XmlDataContext;" + NL + "import com.seitenbau.junit.ITestContext;" + NL + "import com.seitenbau.junit.annotation.ParameterizedTest;" + NL + "import com.seitenbau.junit.annotation.XmlDataOption;" + NL + "import com.seitenbau.junit.annotation.ParameterizedTestField;" + NL + "import com.seitenbau.testing.shared.junit.SBRecorderContext;" + NL + "import com.seitenbau.testing.shared.junit.SBRecorderDataProvider;" + NL + "import com.seitenbau.testing.shared.model.ObjectSnapshot;" + NL + "import com.seitenbau.testing.shared.tracer.TracerControl;" + NL + "" + NL + "import org.junit.*;" + NL + "import org.junit.runner.RunWith;" + NL + "import static junit.framework.Assert.*;";
  protected final String TEXT_4 = NL;
  protected final String TEXT_5 = NL + NL + "@RunWith(ParameterizedTestRunner.class)";
  protected final String TEXT_6 = NL;
  protected final String TEXT_7 = NL + "public class ";
  protected final String TEXT_8 = "Test {" + NL;
  protected final String TEXT_9 = NL;
  protected final String TEXT_10 = NL + "\tprotected ";
  protected final String TEXT_11 = " mySUTInstance;" + NL + "" + NL + "\t@ParameterizedTestField" + NL + "\tprotected SBRecorderContext ";
  protected final String TEXT_12 = ";";
  protected final String TEXT_13 = NL;
  protected final String TEXT_14 = NL + "\t@BeforeClass" + NL + "\tpublic static void setupClass()" + NL + "\t{" + NL + "\t  TracerControl.enableTracer(false);" + NL + "\t}" + NL + "" + NL + "\t@Before" + NL + "\tpublic void setup() throws Exception {" + NL + "\t\tif(";
  protected final String TEXT_15 = "==null) return;" + NL;
  protected final String TEXT_16 = NL;
  protected final String TEXT_17 = NL + "\t}";
  protected final String TEXT_18 = NL + NL + "\t@ParameterizedTest(SBRecorderDataProvider.class)" + NL + "\t@XmlDataOption(file=\"";
  protected final String TEXT_19 = "Test.xml\",passContext=true)";
  protected final String TEXT_20 = NL;
  protected final String TEXT_21 = NL + "\tpublic void ";
  protected final String TEXT_22 = "Test(";
  protected final String TEXT_23 = "/*";
  protected final String TEXT_24 = "*/ ObjectSnapshot expectedReturnValueSnapshot" + NL + "\t";
  protected final String TEXT_25 = ", ";
  protected final String TEXT_26 = ",SBRecorderContext context) throws Exception" + NL + "    {" + NL + "    \t";
  protected final String TEXT_27 = NL + "    \t";
  protected final String TEXT_28 = " ";
  protected final String TEXT_29 = "= ";
  protected final String TEXT_30 = ";" + NL + "    \tif( !myContext.getTestItem().getExpected().isException() ) {" + NL + "    \t\t";
  protected final String TEXT_31 = " = ";
  protected final String TEXT_32 = " (";
  protected final String TEXT_33 = ") ";
  protected final String TEXT_34 = " ";
  protected final String TEXT_35 = ".makeObject( expectedReturnValueSnapshot );" + NL + "    \t}" + NL + "    \t";
  protected final String TEXT_36 = NL;
  protected final String TEXT_37 = NL;
  protected final String TEXT_38 = NL;
  protected final String TEXT_39 = NL + "\t}";
  protected final String TEXT_40 = NL + "\t@After" + NL + "\tpublic void teardown() throws Exception {" + NL + "\t\tif(";
  protected final String TEXT_41 = "==null) return; // Not a DataDrivenTest" + NL;
  protected final String TEXT_42 = NL;
  protected final String TEXT_43 = NL + "\t}" + NL + "" + NL + "\t@AfterClass" + NL + "\tpublic static void teardownClass()" + NL + "\t{" + NL + "\t\tTracerControl.enableTracer(true);" + NL + "\t}";
  protected final String TEXT_44 = NL;
  protected final String TEXT_45 = NL + NL + "}";

	/* (non-javadoc)
    * @see IGenerator#generate(Object)
    */
	@SuppressWarnings("unchecked")
	public String generate(ITemplateParams argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
     
	GeneratorDataDrivenController param=(GeneratorDataDrivenController)argument;

	List<RecordedMethodConfiguration> mlist=param.getRecordedMethodConfigurations();
	RecordedMethodConfiguration first=mlist.get(0);
	String javaPackage=first.getClassPackage();
	String javaClassName=first.getClassName();
	String testClassName = param.getTestClassName();

    
 	param.setFileName( testClassName+"Test.java");

 	ITestPathLocator locator =  param.getPathLocator();
 	param.setFilePath( locator.getTestFolder() );


    
if(javaPackage!=null && javaPackage.length()>0) {
	
    stringBuffer.append(TEXT_1);
    stringBuffer.append(javaPackage);
    stringBuffer.append(TEXT_2);
    
}
    stringBuffer.append(TEXT_3);
    stringBuffer.append(TEXT_4);
    stringBuffer.append(	param.includeImports() );
    stringBuffer.append(TEXT_5);
    stringBuffer.append(TEXT_6);
    stringBuffer.append(	param.includeAnnotationClass() );
    stringBuffer.append(TEXT_7);
    stringBuffer.append(testClassName);
    stringBuffer.append(TEXT_8);
    stringBuffer.append(TEXT_9);
    stringBuffer.append(	param.includeAnnotationFixture() );
    stringBuffer.append(TEXT_10);
    stringBuffer.append(javaClassName);
    stringBuffer.append(TEXT_11);
    stringBuffer.append(TestNameSettings.FIELD_TEST_CONTEXT);
    stringBuffer.append(TEXT_12);
    stringBuffer.append(TEXT_13);
    stringBuffer.append(
	param.includeVariables()
);
    stringBuffer.append(TEXT_14);
    stringBuffer.append(TestNameSettings.FIELD_TEST_CONTEXT);
    stringBuffer.append(TEXT_15);
    stringBuffer.append(TEXT_16);
    stringBuffer.append(
	param.includeBeforeMethod()
);
    stringBuffer.append(TEXT_17);
     // ****************** All Methods ...

for(Iterator<RecordedMethodConfiguration> it=mlist.iterator();it.hasNext();) {
	RecordedMethodConfiguration mcfg=it.next();
	ParameterBuilder pb=new ParameterBuilder( mcfg.getParameters() );
	String javaMethodName=mcfg.getMethodName();
	boolean isVoid=mcfg.getReturnType().equals("void");

    stringBuffer.append(TEXT_18);
    stringBuffer.append(testClassName);
    stringBuffer.append(TEXT_19);
    stringBuffer.append(TEXT_20);
    stringBuffer.append(	param.includeAnnotationTest() );
    stringBuffer.append(TEXT_21);
    stringBuffer.append(javaMethodName);
    stringBuffer.append(TEXT_22);
    
		if( ! isVoid ) {
	
    stringBuffer.append(TEXT_23);
    stringBuffer.append(mcfg.getReturnType());
    stringBuffer.append(TEXT_24);
      }  // !isVoid
	
    
			if( pb.hasParameters() && !isVoid ) { 
    stringBuffer.append(TEXT_25);
     }
			
    stringBuffer.append(pb.buildSignature());
    stringBuffer.append(TEXT_26);
     if( ! isVoid ) { 
    stringBuffer.append(TEXT_27);
    stringBuffer.append(mcfg.getReturnType());
    stringBuffer.append(TEXT_28);
    stringBuffer.append(TestNameSettings.TEST_METHOD_RETURN_VALUE_EXPECTED);
    stringBuffer.append(TEXT_29);
    stringBuffer.append(SBFieldInit.init(mcfg.getReturnType()));
    stringBuffer.append(TEXT_30);
    stringBuffer.append(TestNameSettings.TEST_METHOD_RETURN_VALUE_EXPECTED);
    stringBuffer.append(TEXT_31);
    
    		if( TypeWrapper.isPrimitiveType( mcfg.getReturnType() ) ) {
    			
    stringBuffer.append(TEXT_32);
    stringBuffer.append(TypeWrapper.wrap(mcfg.getReturnType()));
    stringBuffer.append(TEXT_33);
    
    		}
    		
    stringBuffer.append(TEXT_34);
    stringBuffer.append(TestNameSettings.FIELD_TEST_CONTEXT);
    stringBuffer.append(TEXT_35);
     } // !isVoid 
    stringBuffer.append(TEXT_36);
    stringBuffer.append(	param.includeBeforeTest() );
    stringBuffer.append(TEXT_37);
    stringBuffer.append( new JUnit4_DataDrivenTestInvocationGenerator().generate( new SimpleModelParam( mcfg, param) ));
    stringBuffer.append(TEXT_38);
    stringBuffer.append(	param.includeAfterTest() );
    stringBuffer.append(TEXT_39);
     } 
    stringBuffer.append(TEXT_40);
    stringBuffer.append(TestNameSettings.FIELD_TEST_CONTEXT);
    stringBuffer.append(TEXT_41);
    stringBuffer.append(TEXT_42);
    stringBuffer.append(	param.includeAfterMethod() );
    stringBuffer.append(TEXT_43);
    stringBuffer.append(TEXT_44);
    stringBuffer.append(	param.includeOtherCode() );
     	//param.createArtifacts( param.getFilePath() ); 
    stringBuffer.append(TEXT_45);
    return stringBuffer.toString();
  }
}