package com.seitenbau.testing.templates;

import com.seitenbau.testing.shared.templateengine.ITemplateParams;
import com.seitenbau.testing.shared.templateengine.IGenerator;

import java.util.*;
import com.seitenbau.testing.shared.model.*;
import com.seitenbau.testing.shared.locator.*;
import com.seitenbau.testing.testgenerator.datadriven.*;

public class JUnit4_DataDrivenTestXmlGenerator implements IGenerator
{
  protected static String nl;
  public static synchronized JUnit4_DataDrivenTestXmlGenerator create(String lineSeparator)
  {
    nl = lineSeparator;
    JUnit4_DataDrivenTestXmlGenerator result = new JUnit4_DataDrivenTestXmlGenerator();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "<testfile>";
  protected final String TEXT_2 = NL + "     <targetClassName>";
  protected final String TEXT_3 = "</targetClassName>" + NL + "    <tests>";
  protected final String TEXT_4 = NL + "    <test id=\"";
  protected final String TEXT_5 = "\" name=\"Test";
  protected final String TEXT_6 = "\">" + NL + "      <parameters> ";
  protected final String TEXT_7 = NL + "      <ObjectSnapshot>";
  protected final String TEXT_8 = "</ObjectSnapshot>";
  protected final String TEXT_9 = NL + "      </parameters>";
  protected final String TEXT_10 = NL + "      <expected";
  protected final String TEXT_11 = " isException=\"true\" ";
  protected final String TEXT_12 = ">";
  protected final String TEXT_13 = "<expectedResult class=\"ObjectSnapshot\">";
  protected final String TEXT_14 = NL + "      ";
  protected final String TEXT_15 = NL + "      </expectedResult>";
  protected final String TEXT_16 = NL + "         <expectedException class=\"ObjectSnapshot\">";
  protected final String TEXT_17 = NL + "         ";
  protected final String TEXT_18 = NL + "         </expectedException>";
  protected final String TEXT_19 = NL + "      </expected>";
  protected final String TEXT_20 = NL + "    </test>";
  protected final String TEXT_21 = NL + "  </tests>" + NL + "</testfile>";
  protected final String TEXT_22 = NL;

	/* (non-javadoc)
    * @see IGenerator#generate(Object)
    */
	@SuppressWarnings("unchecked")
	public String generate(ITemplateParams argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
  DataDrivenXmlController param=(DataDrivenXmlController)argument;


  RecordedMethodConfiguration mcfg=param.getCurrentRecordedMethod();

  String javaClassName=mcfg.getClassName();
  String testClassName=param.getTestClassName();


    
   param.setFileName(testClassName+"Test.xml");

  ITestPathLocator locator =  param.getPathLocator();
   param.setFilePath( locator.getTestResourceFolder() );


    stringBuffer.append(TEXT_1);
    //new XStream().toXML(param.getProperties())
    stringBuffer.append(TEXT_2);
    stringBuffer.append(javaClassName);
    stringBuffer.append(TEXT_3);
    
  List<RecordedTestCase> testcases = mcfg.getRecordedTestCases();
  int i=0;
  for(Iterator<RecordedTestCase> it=testcases.iterator();it.hasNext();) {
    RecordedTestCase testCase=it.next();
  List<RecordedTest> tests=testCase.getRecordedTests();
  RecordedTest test;
  for(Iterator<RecordedTest> testIt=tests.iterator();testIt.hasNext();) {
    test=testIt.next();

    stringBuffer.append(TEXT_4);
    stringBuffer.append(test.getId());
    stringBuffer.append(TEXT_5);
    stringBuffer.append(i);
    stringBuffer.append(TEXT_6);
    
      ObjectSnapshot[] arguments=test.getArgumentValues();
      for(int argI=0;argI<test.getArgumentValues().length;argI++) {
        ObjectSnapshot os=arguments[argI];
      
    stringBuffer.append(TEXT_7);
    stringBuffer.append(os.getXMLString()
      );
    stringBuffer.append(TEXT_8);
     } 
    stringBuffer.append(TEXT_9);
    if(test.getReturnValue()!=null || test.isExceptionThrown() ) { 
    stringBuffer.append(TEXT_10);
    
        if( test.isExceptionThrown() ) {
        
    stringBuffer.append(TEXT_11);
    
        }
      
    stringBuffer.append(TEXT_12);
    
        String xml;
        if( test.getReturnValue()==null) {
        	xml="<null/>";
        } else {
        	xml=test.getReturnValue().getXMLString();
        }
      
    stringBuffer.append(TEXT_13);
    stringBuffer.append(TEXT_14);
    stringBuffer.append(xml);
    stringBuffer.append(TEXT_15);
     if( test.isExceptionThrown() )
         {
           String exceptionXML=test.getExceptionValue().getXMLString(); 
    stringBuffer.append(TEXT_16);
    stringBuffer.append(TEXT_17);
    stringBuffer.append(exceptionXML);
    stringBuffer.append(TEXT_18);
     } 
    stringBuffer.append(TEXT_19);
     } 
    stringBuffer.append(TEXT_20);
    
    i++;
    }
  } // end for each test

    stringBuffer.append(TEXT_21);
    stringBuffer.append(TEXT_22);
    return stringBuffer.toString();
  }
}