package com.seitenbau.testing.templates;

import com.seitenbau.testing.shared.templateengine.ITemplateParams;
import com.seitenbau.testing.shared.templateengine.IGenerator;

import com.seitenbau.testing.instrumentation.generator.*;
import com.seitenbau.testing.shared.config.*;

public class Record_AspectGenerator implements IGenerator
{
  protected static String nl;
  public static synchronized Record_AspectGenerator create(String lineSeparator)
  {
    nl = lineSeparator;
    Record_AspectGenerator result = new Record_AspectGenerator();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "package ";
  protected final String TEXT_2 = ";";
  protected final String TEXT_3 = NL + NL + "import java.util.Properties;" + NL + "" + NL + "import com.seitenbau.testing.shared.aspects.AbstractBaseAspect;" + NL + "import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;" + NL + "import com.seitenbau.testing.shared.tracer.RecordTracer;" + NL + "import com.seitenbau.testing.shared.tracer.ITracer;" + NL + "import com.seitenbau.testing.shared.tracer.TracerFactory;" + NL + "import com.seitenbau.testing.shared.tracer.NullTracer;" + NL + "import com.seitenbau.testing.shared.dao.DaoFactory;" + NL + "import com.seitenbau.testing.shared.dao.IDaoFactory;" + NL + "import com.seitenbau.testing.shared.config.RecorderConfiguration;" + NL + "import com.seitenbau.testing.shared.config.MethodConfiguration;" + NL + "" + NL + "" + NL + "/**" + NL + "*  This code was generated via a template. Do not change it manually!" + NL + "*/" + NL + "public abstract aspect ";
  protected final String TEXT_4 = "Aspect extends AbstractBaseAspect {" + NL + "" + NL + "\tprotected pointcut pc_Exclude() : !cflow( execution(* *Test.*(..)) );" + NL + "" + NL + "\tprivate static RecorderConfiguration theConfig=null;" + NL + "" + NL + "\tprotected RecorderConfiguration getConfiguration()" + NL + "\t{" + NL + "\t\tif(theConfig==null) {" + NL + "\t\t\ttheConfig=RecorderConfiguration" + NL + "\t\t\t\t\t\t.loadFromStream(" + NL + "\t\t\t\t\t\t\t\tgetClass().getResourceAsStream(\"";
  protected final String TEXT_5 = ".record.xml\")" + NL + "\t\t\t\t\t\t\t);" + NL + "\t\t}" + NL + "\t\treturn theConfig;" + NL + "\t}" + NL + "" + NL + "\tprotected IDaoFactory getStaticDaoFactory()" + NL + "\t{" + NL + "\t\treturn DaoFactory.create(getConfiguration());" + NL + "\t}" + NL + "}" + NL;
  protected final String TEXT_6 = NL;
  protected final String TEXT_7 = NL;

	/* (non-javadoc)
    * @see IGenerator#generate(Object)
    */
	@SuppressWarnings("unchecked")
	public String generate(ITemplateParams argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
	if( ! (argument instanceof RecorderParams) ) {
		throw
			new IllegalArgumentException("Expected RecorderParams as argument to Template"
											+ getClass().getName() );
	}
	RecorderParams param=(RecorderParams)argument;

	RecorderConfiguration rcfg= param.getConfig();

	if(rcfg.getMethodConfiguration() == null || rcfg.getMethodConfiguration().isEmpty()) {
		throw
			new IllegalArgumentException("Expected at least one MethodConfiguration in Template:"
											+ getClass().getName() );
	}
	MethodConfiguration mcfg=rcfg.getMethodConfiguration().get(0);

	String packagePath=mcfg.getPackageName();
//	if(rcfg.getGlobal() !=null && rcfg.getGlobal().getPackageName()!=null) {
//		packagePath=rcfg.getGlobal().getPackageName();
//	}

	String baseName = rcfg.getBaseName()+mcfg.getClassName();

	// Pass back the File Name & path
	param.setFileName(baseName+"Aspect.aj");

	StringBuffer sb=new StringBuffer()
		.append(param.getSourceRoot())
		.append("/")
		.append(packagePath.replace(".","/"))
		.append("/");
	param.setFilePath(sb.toString());

     if( packagePath !=null && packagePath.length()>0) { 
    stringBuffer.append(TEXT_1);
    stringBuffer.append(packagePath);
    stringBuffer.append(TEXT_2);
     } 
    stringBuffer.append(TEXT_3);
    stringBuffer.append(baseName);
    stringBuffer.append(TEXT_4);
    stringBuffer.append(baseName);
    stringBuffer.append(TEXT_5);
    stringBuffer.append(TEXT_6);
    stringBuffer.append(new Record_AspectIncludeGenerator().generate(param));
    stringBuffer.append(TEXT_7);
    return stringBuffer.toString();
  }
}