package com.seitenbau.testing.testgenerator.partgenerator;

import java.util.List;

import com.seitenbau.testing.shared.locator.ITestPathFileBasedLocator;
import com.seitenbau.testing.shared.model.RecordedMethodConfiguration;


/**
 * Defines an additional init method for a PartGenerator
 * 
 * This method is called just before the Generator is running. When
 * building the Generator model it could be that some Code need an
 * initialization after the model was build up. This is for what the
 * init method is fore.
 */
public interface IInitPartGenerator
{

  void init(List<RecordedMethodConfiguration> config,
      ITestPathFileBasedLocator pathLocator);

}
