package com.seitenbau.testing.testgenerator.partgenerator.velocity;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.apache.commons.collections.ExtendedProperties;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.resource.loader.StringResourceLoader;
import org.apache.velocity.runtime.resource.util.StringResource;
import org.apache.velocity.runtime.resource.util.StringResourceRepository;
import org.apache.velocity.runtime.resource.util.StringResourceRepositoryImpl;

public class OwnVelocityResourceLoader extends StringResourceLoader
{

  private StringResourceRepository myRepo;

  public OwnVelocityResourceLoader(StringResourceRepository repoLoader)
  {
    myRepo = repoLoader;
  }

  public static StringResourceRepository getRepository()
  {
    StringResourceRepositoryImpl rep = new StringResourceRepositoryImpl();
    return rep;
  }

  @Override
  public InputStream getResourceStream(String arg0)
      throws ResourceNotFoundException
  {
    // System.out.println("getResourceStream"+arg0);
    StringResource res = myRepo.getStringResource(arg0);
    if (res == null)
    {
      return null;
    }
    ByteArrayInputStream b = new ByteArrayInputStream(res.getBody().getBytes());
    return b;
  }

  @Override
  public void init(ExtendedProperties configuration)
  {
    // System.out.println("init");
    super.init(configuration);
  }

}
